=== debian/changelog ===
glewlwyd (2.7.5-3+deb12u1) bookworm; urgency=medium

  * d/patches: Fix CVE-2023-49208
    possible buffer overflow during FIDO2 credentials validation
  * d/patches: Fix CVE-2024-25715
    open redirection via redirect_uri

 -- Nicolas Mora <babelouest@debian.org>  Thu, 23 Nov 2023 17:12:13 -0500

glewlwyd (2.7.5-3) unstable; urgency=medium

  * Install config.json as config-2.7.json (Closes: #1035503)
  * d/glewlwyd-debian.conf.properties: disable user_middleware_module_path

 -- Nicolas Mora <babelouest@debian.org>  Thu, 04 May 2023 07:21:27 -0400

glewlwyd (2.7.5-2) unstable; urgency=medium

  * d/control: add adduser as glewlwyd package dependency, fix piuparts issue
  * d/control: Update description
  * d/control: remove lsb-base from package dependencies
  * d/NEWS: Add message on bullseye upgrade
  * d/Readme.Debian: Add readme to document bullseye transition

 -- Nicolas Mora <babelouest@debian.org>  Tue, 17 Jan 2023 07:24:23 -0500

glewlwyd (2.7.5-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/copyright: Update copyright year to 2023 for debian/* files
  * d/glewlwyd-common.install: restore link bootstrap, jquery and
    fork-awesome
  * d/glewlwyd-debian.conf.properties: disable static_files_path
  * d/glewlwyd-apache.conf: Add apache sample config file

 -- Nicolas Mora <babelouest@debian.org>  Mon, 16 Jan 2023 07:08:39 -0500

glewlwyd (2.7.4-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:29:50 -0400

glewlwyd (2.7.3-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update description

 -- Nicolas Mora <babelouest@debian.org>  Thu, 25 Aug 2022 07:21:46 -0400

glewlwyd (2.7.2-2) unstable; urgency=medium

  * debian/control: change dependency node-react to node-react-dom
                    Thanks to Yadd for the hint (Closes: #1014681)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 18 Jul 2022 18:05:19 +0200
