=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
         , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
# Backend dependencies
             , pkg-config
             , po-debconf
             , libmicrohttpd-dev
             , libjansson-dev
             , libcurl4-gnutls-dev
             , libldap2-dev
             , libsqlite3-dev
             , libconfig-dev
             , libgnutls28-dev
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , libhoel-dev
             , librhonabwy-dev
             , libiddawc-dev
             , liboath-dev
             , libcbor-dev
             , cmake
# Front-end dependencies
Build-Depends-Indep: nodejs
             , node-react-dom
             , node-babel7
             , node-babel-loader
             , node-css-loader
             , node-i18next
             , node-i18next-browser-languagedetector
             , node-i18next-http-backend
             , node-qrcode-generator
             , webpack
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
Standards-Version: 4.6.2
Homepage: https://github.com/babelouest/glewlwyd
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Rules-Requires-Root: no

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends},
       , ${misc:Depends}
       , glewlwyd-common
       , sqlite3
       , ucf
       , dbconfig-mysql | dbconfig-sqlite3 | dbconfig-pgsql | dbconfig-no-thanks
       , adduser
Pre-Depends: ${misc:Pre-Depends}
Suggests: rnbyc
Description: Experimental Single-Sign-On server with multiple factor authentication
 Experimental Single Sign On server, OAuth2, Openid Connect, multiple factor
 authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via
 plugins.
 .
 It's recommended not to use Glewlwyd in production, more likely to test
 OAuth2/OpenID behavior, MFA connections, or IdP in general. You can also
 explore its functionalities and help yourself with its source code for other
 implementations.
 .
 If you intend to use it in production, it's highly recommended to follow the
 documentation and enable only the features you will use.
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers

Package: glewlwyd-common
Depends: ${misc:Depends}
         , fonts-fork-awesome
         , libjs-jquery
         , libjs-bootstrap4
         , libjs-popper.js
Pre-Depends: ${misc:Pre-Depends}
Architecture: all
Multi-Arch: foreign
Description: Experimental Single-Sign-On server - common files
 Experimental Single Sign On server, OAuth2, Openid Connect, multiple factor
 authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via
 plugins.
 .
 It's recommended not to use Glewlwyd in production, more likely to test
 OAuth2/OpenID behavior, MFA connections, or IdP in general. You can also
 explore its functionalities and help yourself with its source code for other
 implementations.
 .
 If you intend to use it in production, it's highly recommended to follow the
 documentation and enable only the features you will use.
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 This package contains the architecture independent files.
