=== debian/watch ===
version=4
# https://github.com/babelouest/glewlwyd
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/glewlwyd-$1/ \
 https://github.com/babelouest/glewlwyd/tags .*/v?([\d\.]+).tar.gz
